/* as_psc.c was originally generated by the autoSql program, which also 
 * generated as_psc.h and as_psc.sql.  This module links the database and the RAM 
 * representation of objects. */

#include "common.h"
#include "jksql.h"
#include "as_psc.h"

struct psc *pscLoad(char **row)
/* Load a psc from row fetched with select * from psc
 * from database.  Dispose of this with pscFree(). */
{
struct psc *ret;
int sizeOne,i;
char *s;

AllocVar(ret);
ret->blockCount = sqlUnsigned(row[9]);
ret->score = sqlUnsigned(row[0]);
strcpy(ret->qAcc, row[1]);
ret->qStart = sqlUnsigned(row[2]);
ret->qEnd = sqlUnsigned(row[3]);
ret->qSize = sqlUnsigned(row[4]);
strcpy(ret->tAcc, row[5]);
ret->tStart = sqlUnsigned(row[6]);
ret->tEnd = sqlUnsigned(row[7]);
ret->tSize = sqlUnsigned(row[8]);
sqlUnsignedDynamicArray(row[10], &ret->blockSizes, &sizeOne);
assert(sizeOne == ret->blockCount);
sqlUnsignedDynamicArray(row[11], &ret->qBlockStarts, &sizeOne);
assert(sizeOne == ret->blockCount);
sqlUnsignedDynamicArray(row[12], &ret->tBlockStarts, &sizeOne);
assert(sizeOne == ret->blockCount);
return ret;
}

struct psc *pscCommaIn(char **pS, struct psc *ret)
/* Create a psc out of a comma separated string. 
 * This will fill in ret if non-null, otherwise will
 * return a new psc */
{
char *s = *pS;
int i;

if (ret == NULL)
    AllocVar(ret);
ret->score = sqlUnsignedComma(&s);
sqlFixedStringComma(&s, ret->qAcc, sizeof(ret->qAcc));
ret->qStart = sqlUnsignedComma(&s);
ret->qEnd = sqlUnsignedComma(&s);
ret->qSize = sqlUnsignedComma(&s);
sqlFixedStringComma(&s, ret->tAcc, sizeof(ret->tAcc));
ret->tStart = sqlUnsignedComma(&s);
ret->tEnd = sqlUnsignedComma(&s);
ret->tSize = sqlUnsignedComma(&s);
ret->blockCount = sqlUnsignedComma(&s);
s = sqlEatChar(s, '{');
AllocArray(ret->blockSizes, ret->blockCount);
for (i=0; i<ret->blockCount; ++i)
    {
    ret->blockSizes[i] = sqlUnsignedComma(&s);
    }
s = sqlEatChar(s, '}');
s = sqlEatChar(s, ',');
s = sqlEatChar(s, '{');
AllocArray(ret->qBlockStarts, ret->blockCount);
for (i=0; i<ret->blockCount; ++i)
    {
    ret->qBlockStarts[i] = sqlUnsignedComma(&s);
    }
s = sqlEatChar(s, '}');
s = sqlEatChar(s, ',');
s = sqlEatChar(s, '{');
AllocArray(ret->tBlockStarts, ret->blockCount);
for (i=0; i<ret->blockCount; ++i)
    {
    ret->tBlockStarts[i] = sqlUnsignedComma(&s);
    }
s = sqlEatChar(s, '}');
s = sqlEatChar(s, ',');
*pS = s;
return ret;
}

void pscFree(struct psc **pEl)
/* Free a single dynamically allocated psc such as created
 * with pscLoad(). */
{
struct psc *el;

if ((el = *pEl) == NULL) return;
freeMem(el->blockSizes);
freeMem(el->qBlockStarts);
freeMem(el->tBlockStarts);
freez(pEl);
}

void pscFreeList(struct psc **pList)
/* Free a list of dynamically allocated psc's */
{
struct psc *el, *next;

for (el = *pList; el != NULL; el = next)
    {
    next = el->next;
    pscFree(&el);
    }
*pList = NULL;
}

void pscOutput(struct psc *el, FILE *f, char sep, char lastSep) 
/* Print out psc.  Separate fields with sep. Follow last field with lastSep. */
{
int i;
fprintf(f, "%u", el->score, sep);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->qAcc, sep);
if (sep == ',') fputc('"',f);
fputc(sep,f);
fprintf(f, "%u", el->qStart, sep);
fputc(sep,f);
fprintf(f, "%u", el->qEnd, sep);
fputc(sep,f);
fprintf(f, "%u", el->qSize, sep);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->tAcc, sep);
if (sep == ',') fputc('"',f);
fputc(sep,f);
fprintf(f, "%u", el->tStart, sep);
fputc(sep,f);
fprintf(f, "%u", el->tEnd, sep);
fputc(sep,f);
fprintf(f, "%u", el->tSize, sep);
fputc(sep,f);
fprintf(f, "%u", el->blockCount, sep);
fputc(sep,f);
if (sep == ',') fputc('{',f);
for (i=0; i<el->blockCount; ++i)
    {
    fprintf(f, "%u", el->blockSizes[i]);
    fputc(',', f);
    }
if (sep == ',') fputc('}',f);
fputc(sep,f);
if (sep == ',') fputc('{',f);
for (i=0; i<el->blockCount; ++i)
    {
    fprintf(f, "%u", el->qBlockStarts[i]);
    fputc(',', f);
    }
if (sep == ',') fputc('}',f);
fputc(sep,f);
if (sep == ',') fputc('{',f);
for (i=0; i<el->blockCount; ++i)
    {
    fprintf(f, "%u", el->tBlockStarts[i]);
    fputc(',', f);
    }
if (sep == ',') fputc('}',f);
fputc(lastSep,f);
}

